;**********************************************************************;
;*                       C O M _ R A M . A S M                        *;
;*--------------------------------------------------------------------*;
;*    Fonction        : Outil de dveloppement de programmes COM en   *;
;*                      Assembleur avec le Turbo Assembleur TASM ou   *;
;*                      le Macro Assembler MASM de Microsoft          *;
;*--------------------------------------------------------------------*;
;*    Auteur          : MICHAEL TISCHER                               *;
;*    Dvelopp le    : 07.06.1987                                    *;
;*    Dernire modif. : 10.10.1991                                    *;
;*--------------------------------------------------------------------*;
;*    Dveloppement    : MASM:   masm com_ram;                        *;
;*                              link com_ram;                         *;
;*                              exe2bin com_ram.exe com_ram.com       *;
;*                                                                    *;
;*                       TASM:  tasm com_ram                          *;
;*                              tlink /t com_ram                      *;
;**********************************************************************;

com       segment para 'CODE'               ;Dfinition d'un segment COM
                                    ;(le nom peut tre choisi librement)

          org 100h                    ;Le code commence  l'adresse 100h
                                           ;obligatoirement aprs le PSP

          assume cs:com, ds:com, es:com, ss:com

                                      ;Pendant l'excution du programme,
                                ;tous les registres de segment dsignent
                                                         ;le segment COM

start:    jmp  init               ;Ici commence l'excution du programme
                                  ;Saut vers la routine d'initialisation

;== Donnes ============================================================

          ;-- Ici, vous pouvez mettre en place toutes les donnes, le --
                                          ;-- le buffer et les variables

                                                                    ;...
                                                                    ;...
                                                                    ;...

;== Programme principal ================================================

prog      proc near             ;Cette procdure reprsente le programme
                       ;principal  proprement parler. Elle est excute
                                       ;aprs le lancement du programme.

                 ;-- Ici, vous pouvez inclure le code programme du------
                                                 ;-- programme principal

                                                                    ;...
                                                                    ;...
                                                                    ;...

    ;--- Terminer le programme  l'aide de la fonction DOS 4Ch ---------

          mov  ax,4C00h  ;Charger le numro de fonction, code d'erreur 0
          int  21h                                           ;Appels DOS

      ;--- Ici l'excution du programme n'a plus aucun sens parce que --
                       ;--- l'appel DOS prcdent a mis fin au programme

prog      endp                               ;Fin du programme principal

;-- Sous-routines ------------------------------------------------------
;-- Cette place est rserve aux sous-routines du programme

a_proc    proc near

                                                                    ;...
                                                                    ;...
                                                                    ;...
          ret

a_proc    endp

b_proc    proc near

                                                                    ;...
                                                                    ;...
                                                                    ;...
          ret

b_proc    endp

;-- Initialisation ----------------------------------------------------
;-- Ici, toute la mmoire est libre aprs le label FIN
;-- et la pile rorganise.

init:     mov  ah,4Ah         ;N fonc. pour "Changer la taille mmoire"
          mov  bx,offset fin      ;Arrondir la longueur du programme aux
          add  bx,15               ;paragraphes suivants dans la mmoire
          mov  cl,4                         ;Calculer l'adresse d'offset
          shr  bx,cl                                     ;en paragraphes
          inc  bx
          int  21h                 ;Appeler la fonction par l'inter. DOS

          mov  sp,offset fin                        ;Rorganiser la pile
          jmp  prog                  ;Sauter vers le programme principal

init_fin label near

;== Pile ==============================================================

          dw (256-((init_fin-init) shr 1)) dup (?)

                                   ;La pile comprend 256 mots et termine
                                 ;le code de la routine INIT qui devient
                                                      ;inutile aprs son
                                                              ;excution

fin      equ this byte            ;Fin de la mmoire occupe, aucun code
                                               ;ne doit plus faire suite

;== Fin ===============================================================

com       ends                                       ;Fin du segment COM
          end  start             ;Fin du programme Assembleur. Commencer
                                   ;l'excution avec l'instruction START
