;**********************************************************************;
;*                       E X E _ R A M . A S M                        *;
;*--------------------------------------------------------------------*;
;*    Fonction        : Outil de dveloppement de programmes EXE en   *;
;*                     Assembleur avec le Turbo Assembleur TASM ou    *;
;*                     le Macro Assembler MASM de Microsoft           *;
;*--------------------------------------------------------------------*;
;*    Auteur          : MICHAEL TISCHER                               *;
;*    Dvelopp le   :  7.06.1987                                     *;
;*    Dernire modif. : 10.10.1991                                    *;
;*--------------------------------------------------------------------*;
;*    Dveloppement    : MASM: masm exe_ram;                          *;
;*                             link exe_ram;                          *;
;*                                                                    *;
;*                     TASM:   tasm exe_ram                           *;
;*                             tlink exe_ram                          *;
;**********************************************************************;

;== Pile ==============================================================

stackseg  segment para STACK 'STACK'      ;Dfinition du segment de pile

          dw 256 dup (?)                      ;La pile comprend 256 mots

stackseg  ends                                   ;Fin du segment de pile

;== Donnes ============================================================

data      segment para 'DATA'          ;Dfinition du segment de donnes

                 ;-- Ici vous pouvez mettre en place toutes les donnes,
                                          ;-- le buffer et les variables

                                                                    ;...
                                                                    ;...
                                                                    ;...

data      ends                                ;Fin du segment de donnes

;== Code ===============================================================

code      segment para 'CODE'             ;Dfinition du segment de code

          assume cs:code, ds:data, ss:stackseg

                          ;CS concerne le segment de code, DS le segment
                                   ;de donnes et SS le segment de pile.
                                                   ;ES peut tre utilis
                                                             ;librement.

prog      proc far              ;Cette procdure reprsente le programme
                       ;principal  proprement parler. Elle est excute
                                       ;aprs le lancement du programme.

                    ;-- A ce niveau, CS et SS sont dj initialiss. ---
         ;-- Il ne reste plus qu' initialiser DS  la main, parce qu'il
                                       ;-- dsigne le PSP tout comme ES.

          mov  ax,data       ;Charger l'adresse de segment du segment de
          mov  ds,ax                        ;donnes dans le registre DS

          call setfree                ;Librer la mmoire non ncessaire

         ;-- Ici vous pouvezinclure le code programme du programme-----
                                                           ;-- principal

                                                                    ;...
                                                                    ;...
                                                                    ;...

        ;--- Terminer le programme  l'aide de la fonction 4Ch ---------

          mov  ax,4C00h  ;Charger le numro de fonction, code d'erreur 0
          int  21h                                           ;Appels DOS

      ;--- Ici l'excution du programme n'a plus aucun sens parce que --
                       ;--- l'appel DOS prcdent a mis fin au programme

prog      endp                                 ;Fin de la procdure PROG

;-- Sous-routines ------------------------------------------------------
;-- Cette place est rserve aux sous-routines du programme

a_proc    proc near
                                                                    ;...
                                                                    ;...
                                                                    ;...
          ret

a_proc    endp

b_proc    proc near

                                                                    ;...
                                                                    ;...
                                                                    ;...
          ret

b_proc    endp

;-- SETFREE: Librer la place mmoire non occupe ----------------
;-- Entre  : ES = Adresse du PSP
;-- Sortie  : Aucune
;-- Register : AX, BX, CL et les FLAGS sont modifis
;-- Infos   : Comme le segment de pile est toujours le dernier segment
;             d'un  fichier EXE, ES:0000 dsigne le dbut du programme
;             dans la mmoire et SS:SP la fin. Cela permet donc de
;             calculer la longueur du programme
setfree   proc near

          mov  bx,ss      ;Calculer l'intervalle entre le PSP et la pile
          mov  ax,es                                     ;en paragraphes
          sub  bx,ax

          mov  ax,sp                      ;Calculer l'tat de la pile en
          add  ax,15                                     ;en paragraphes
          mov  cl,4
          shr  ax,cl                       ;Contenu, longueur de la pile

          add  bx,ax                           ;Ajouter les deux valeurs

          mov  ah,4ah                   ;Seule cette mmoire doit rester
          int  21h                                             ;rserve

          ret                               ;Retour au programme d'appel

setfree   endp

;== Fin ===============================================================

code      ends                                   ;Fin du segment de code
          end  prog                       ;Commencer l'excution avec la
                                                         ;procdure PROG

