;**********************************************************************;
;*                           M A C R O K E Y                          *;
;*--------------------------------------------------------------------*;
;*    Fonction     : Montre comment on dfinit des touches de         *;
;*                   macro commande en reprogrammant le gestionnaire  *;
;*                   de l'interruption 16h du BIOS                    *;
;*--------------------------------------------------------------------*;
;*    Auteur                : MICHAEL TISCHER                         *;
;*    Dvelopp le          : 03.01.1992                              *;
;*    Dernire modification : 03.01.1992                              *;
;*--------------------------------------------------------------------*;
;*    Assemblage     : MASM MACROKEY                                  *;
;*                     LINK MACKROKEY                                 *;
;*                     EXE2BIN MACROKEY MACROKEY.COM                  *;
;*                                                                    *;
;*                     ou                                             *;
;*                                                                    *;
;*                     TASM MACROKEY                                  *;
;*                     TLINK /t MACROKEY                              *;
;*--------------------------------------------------------------------*;
;*    Appel          : MACROKEY                                       *;
;**********************************************************************;

;== Dbut du programme

code  segment para 'CODE'                 ;Dfinition du segment de code

      org 100h

      assume cs:code, ds:code, es:code, ss:code

start: jmp  mkinit                  ;Appel des routines d'initialisation

;== Donnes (restant en mmoire ) ======================================

ancint    equ this dword              ;Ancien vecteur d'interruption 16h
intancofs dw (?)                   ;Offset du vecteur d'interruption 16h
intancseg dw (?)                  ;Segment du vecteur d'interruption 16h

mkey      dw 3100h                        ;Touche d'activation : ALT + N
mstart    db "Micro Application"                      ;Texte de la macro
mend      equ this byte

mofs      dw 0FFFFh                             ;Pointe sur le caractre
                                           ;suivant du texte de la macro
                                                      ;Texte de la macro

;== Ceci est la nouvelle interruption        16h (reste en mmoire  ) =

nouvi16    proc far

      assume cs:code, ds:nothing, es:nothing, ss:nothing

      sti                          ;Autorise  nouveau les interruptions
      jmp  short ni1

      db "MT"                               ;Identification du programme

ni1:          ;-- teste d'abord si le nouveau gestionnaire est comptent
                                            ;-- pour la fonction appele

      or   ah,ah                                   ;Fonction 00h ou 10h?
      je   fct0
      cmp  ah,10h
      je   fct0

      cmp  ah,01h                                  ;fonction 01h ou 11h?
      je   fct1
      cmp  ah,11h
      je   fct1

      jmp  cs:[ancint]                  ;non, faire excuter la fonction
                                              ;par l'ancien gestionnaire

fct0:     ;-- fonction 00h/10h -----------------------------------------

      cmp  mofs,offset mend           ;Macro dj en cours d'excution ?
      jae  check0                                  ;non, teste la touche

       ;-- La macro est dj en excution, passe au caractre suivant --

fct0p: push bx                                       ;BX va tre modifi
       mov  bx,mofs                               ;Position du caractre
       mov  al,cs:[bx]                             ;Charge le code ASCII
       xor  ah,ah                                     ;0 comme Scan-Code
       inc  mofs                   ;MOFS pointe sur le caractre suivant
       pop  bx                                              ;Rtablit BX

niret0:   iret                                      ;Retour  l'appelant

check0:                ;-- teste si la touche d'activation a t presse

      pushf                               ;Appelle l'ancien gestionnaire
      call cs:[ancint]
      cmp  ax,mkey               ;A-t-on frapp la touche d'activation ?
      jne  niret0                              ;Non, retour  l'appelant

        ;-- La touche d'activation a t dtecte  ---------------------

      mov  mofs,offset mstart            ;Pointeur sur le dbut du texte
      jmp  fct0p                           ;Renvoie le premier caractre

fct1:     ;-- fonction 01h/11h -----------------------------------------

      cmp  mofs,offset mend                            ;Macro termine ?
      jae  check1                                     ;Non, teste touche

       ;-- La macro est dj en excution, passe au caractre suivant --

fct1p: push bx                                       ;BX va tre modifi
      mov  bx,mofs                                ;Position du caractre
      mov  al,cs:[bx]                              ;Charge le code ASCII
      xor  ah,ah                                      ;0 comme Scan-Code
      pop  bx                                               ;Rtablit BX
      cmp  ah,1              ;Indicateur de zro=0: caractre disponible

niret1:   ret 2                                ;Retour  l'appelant avec
                                                  ; nettoyage de la pile

check1: ;-- teste si la touche d'activation a t presse---------------

      pushf                               ;Appelle l'ancien gestionnaire
      call cs:[ancint]
      je   niret1               ;Pas de touche dans le buffer du clavier

      cmp  ax,mkey               ;A-t-on frapp la touche d'activation ?
      je   check1a                                                  ;Oui

      cmp  ax,0          ;Indicateur de zro = 0 : caractre  disponible
      ret 2 ;Retour  l'appelant;les indicateurs sont retirs de la pile

check1a:  ;-- Touche d'activation dtecte, excute la macro------------

      xor  ah,ah                          ;Retire la touche d'activation
      pushf
      call cs:[ancint]

      mov  mofs,offset mstart              ;Pointe sur le dbut du texte
      jmp  fct1p                           ;renvoie le premier caractre

nouvi16    endp

;== Fin de la partie rsidente ===============

instend   equ this byte

;== Donnes (susceptibles d'tre crases par DOS ) ====================

installm  db "MACROKEY  -  (c) 1992 by Michael Tischer", 13, 10, 13, 10
          db "Programme install ", 13, 10
          db "Peut tre dsactiv par un nouvel appel"
          db 13, 10, "$"

retire  db "MACROKEY a t dsinstall.", 13, 10, "$"

;== Programme (susceptible d'tre cras par DOS )======================

mkinit    label near                                     ;Initialisation

      assume cs:code, ds:code, es:code, ss:code

          ;-- teste d'abord si le programme a dj t install     ----

      mov  ax,3516h        ;Lit le contenu du vecteur d'interruption 16h
      int  21h                               ;Appelle la fonction de DOS
      cmp  word ptr es:[bx+3],"TM"                   ;Teste si  MACROKEY
      jne  mkinstall                                ;a dj t install

          ;-- Le programme a dj t install - Il faut le dsinstaller
                                         ;-- et le retirer de la mmoire

      mov  dx,es:intancofs             ;Offset de l'interruption     16h
      mov  ax,es:intancseg                ;Segment de l'interruption 16h
      mov  ds,ax                                           ;charg en DS
      mov  ax,2516h                   ;Remet la vieille routine  dans le
      int  21h                            ;vecteur de l'interruption 16h

          ;-- Libre la mmoire de l'ancien MACROKEY       -------------

      mov  bx,es                       ;Mmorise le segment du programme
      mov  es,es:[2Ch]         ;Lit le segment environnement dans le PSP
      mov  ah,49h           ;Libre la mmoire de l'ancien environnement
      int  21h

      mov  es,bx                               ;Exploite la fonction 49h
      mov  ah,49h                               ;pour librer la mmoire
      int  21h                                     ;de l'ancien MACROKEY

      push cs                                                 ;Empile CS
      pop  ds                                    ;et le reprend comme DS

      mov  ah,09h                        ;Message: Programme dsinstall
      mov  dx,offset retire
      int  21h

      mov  ax,4C00h                                 ;Terminaison normale
      int  21h

mkinstall:  ;-- Installe le programme ----------------------------------

      mov  intancseg,es               ;Mmorise le segment et l'offset -
      mov  intancofs,bx                   ;du vecteur d'interruption 16h

      mov  dx,offset nouvi16               ;Offset nouvelle interruption
      mov  ax,2516h                              ;Dtourne le vecteur de
      int  21h                                       ;l'interruption 16h

      mov  dx,offset installm              ;Message : Programme install
      mov  ah,09h                   ;Numro fonction affichage la chane
      int  21h                               ;Appelle la fonction de DOS

                 ;-- Seuls restent rsidents le PSP, la nouvelle routine
                           ;-- d'interruptioon et les donnes associes.

      mov  dx,offset instend              ;Calcule le nombre paragraphes
      add  dx,15                                            ;ncessaires
      mov  cl,4                                                        ;
      shr  dx,cl
      mov  ax,3100h                 ;Termine le programme avec le code 0
      int  21h                                  ;en le laissant rsident

;== Fin ================================================================

code  ends                                       ;Fin du segment de CODE
      end  start

