/***********************************************************************
*                              D I R C 2                               *
**--------------------------------------------------------------------**
*    Fonction        : Affiche tous les fichiers d'un rpertoire       *
*                     y compris les sous-rpertoires et noms           *
*                     de volumes sur l'cran.                          *
*                     La demande des fichiers s'effectue  travers     *
*                     les fonctions prdfinies C.                     *
*                     Reportez-vous galement  DIR1.C                 *
**--------------------------------------------------------------------**
*    Auteur          : MICHAEL TISCHER                                 *
*    Dvelopp le    : 15.10.1991                                      *
*    Dernire modif. : 15.03.1992                                      *
**--------------------------------------------------------------------**
*    Modle de mmoire : SMALL                                         *
***********************************************************************/

/*== Insrer les fichiers Include ====================================*/

#include <dos.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <conio.h>

#ifdef __TURBOC__                             /* Compilateur Turbo C? */
  #include <dir.h>             /* Insrer les fonctions de rpertoire */
#endif

/*== Typedefs ========================================================*/

typedef unsigned char BYTE;     /* Voil comment se bricoler un OCTET */

/*== Constantes ======================================================*/

#define TRUE   ( 0 == 0 )     /* Les constantes facilitent la lecture */
#define FALSE  ( 0 == 1 )                    /* du texte du programme */

#define EINTR  14     /* Autant d'entres sont visibles simultanment */
#define EZ     ((20-EINTR) >> 1)  /* 1re ligne de fentre rpertoire */
#define NOF    0x07                 /* Ecriture blanche sur fond noir */
#define INV    0x70  /* Ecriture noire sur fond blanc (vido inverse) */

#define FA_ALL 0x3F                         /* Tous types de fichiers */

/*== Macros ==========================================================*/

#ifdef MK_FP                             /* Macro MK_FP dj dfinie? */
  #undef MK_FP                            /* Si oui, effacer la macro */
#endif

#define MK_FP(s,o) ((void far *) (((unsigned long) (s)<<16)|(o)))

/*-- Constantes/macros pour rec. de fichiers avec compilateurs -------*/
/*-- Microsoft et Borland                                      -------*/

#ifdef __TURBOC__                             /* Compilateur Turbo C? */
  #define DIRSTRUCT                      struct ffblk
  #define FINDFIRST( path, buf, attr )   findfirst( path, buf, attr )
  #define FINDNEXT( buf )                findnext( buf )
  #define NAME                           ff_name
  #define ATTRIBUT                       ff_attrib
  #define TIME                           ff_ftime
  #define DATE                           ff_fdate
  #define SIZE                           ff_fsize
#else                                             /* Non, Microsoft C */
  #define DIRSTRUCT                      struct find_t
  #define FINDFIRST( path, buf, attr )   _dos_findfirst(path, attr, buf)
  #define FINDNEXT( buf )                _dos_findnext( buf )
  #define NAME                           name
  #define ATTRIBUT                       attrib
  #define TIME                           wr_time
  #define DATE                           wr_date
  #define SIZE                           size
#endif

/***********************************************************************
* PRINT : Comme PRINTF mais inscrit directement la chane              *
*         dans la RAM vido                                            *
* Entre : COLONNE = Colonne de sortie                                 *
*          LIGNE   = Ligne de sortie                                   *
*          COULEUR = Couleur d'affichage                               *
*          STRING  = Pointeur sur la chane PRINTF                     *
*           ...    = Autres arguments                                  *
* Sortie : Aucune                                                      *
***********************************************************************/

void Print( int Colonne, int Ligne, BYTE Couleur, char * String, ...)
{
 struct vr {             /* Une position cran sous forme de 2 octets */
            BYTE caractere,                          /* Le code ASCII */
                 attribut;                    /* L'attribut appropri */
           } far * lptr;      /* Pointeur pour l'accs  la RAM vido */
 va_list parameter;         /* Liste de paramtres pour macros VA_... */
 char    sortie[255],                  /* Buffer pour chane formate */
         *aptr = sortie;                  /* Pour consulter la chane */
 static unsigned int vioseg = 0;
 union REGS          Registre;             /* Registres d'appel d'int */

 if( vioseg == 0 )                                  /* Premier appel? */
 {            /* Oui, dterminer l'adresse de segment de la RAM vido */
   Registre.h.ah = 0x0F;
   int86(0x10, &Registre, &Registre);
   vioseg = ( Registre.h.al == 7 ? 0xb000 : 0xb800 );
 }

 va_start( parameter, String );           /* Convertir les paramtres */
 vsprintf( sortie, String, parameter );                   /* Formater */
 lptr = (struct vr far *)
          MK_FP( vioseg, ( Ligne * 80 + Colonne ) << 1 );

 for( ; *aptr ; )                               /* Examiner la chane */
 {
   lptr->caractere = *aptr++;          /* Caractre dans la RAM vido */
   lptr++->attribut = Couleur;     /* Dfinir l'attribut du caractre */
 }
}

/***********************************************************************
* SCROLLUP: Fait avancer une zone d'cran d'une ou plusieurs lignes    *
*           vers le haut ou l'efface                                   *
* Entre : NOMBRE  = Nombre de lignes  faire dfiler                  *
*          COULEUR = Couleur ou Attribut des lignes vides              *
*          COLSG   = Colonne du coin suprieur gauche de la zone       *
*          LIGNSG  = Ligne du coin suprieur gauche de la zone         *
*          COLID   = Colonne du coin infrieur droit de la zone        *
*          LIGNID  = Ligne du coin infrieur droit de la zone          *
* Sortie : Aucune                                                      *
* Infos    : Si 0 transmis comme nombre : zone cran complte         *
*            par des espaces                                           *
***********************************************************************/

void ScrollUp( BYTE Nombre, BYTE Couleur, BYTE ColSG,
               BYTE LignSG, BYTE ColID, BYTE LignID)
{
 union REGS Registre;            /* Registres pour appel interruption */

 Registre.h.ah = 6;                             /* Numro de fonction */
 Registre.h.al = Nombre;                          /* Nombre de lignes */
 Registre.h.bh = Couleur;              /* Couleur de ligne(s) vide(s) */
 Registre.h.ch = LignSG;             /* Dfinir les coordonnes de la */
 Registre.h.cl = ColSG;           /* fentre cran  faire dfiler ou */
 Registre.h.dh = LignID;                              /* ou  effacer */
 Registre.h.dl = ColID;
 int86(0x10, &Registre, &Registre);     /* Appeler l'interruption 10h */
}

/***********************************************************************
* SETPOS : Dfinit la position du curseur dans la page cran           *
*          actuelle                                                    *
* Entre : COLONNE = Nouvelle colonne du curseur                       *
*          LIGNE   = Nouvelle ligne du curseur                         *
* Sortie : Aucune                                                      *
***********************************************************************/

void SetPos( BYTE Colonne, BYTE Ligne)
{
 union REGS Registre;            /* Registres pour appel interruption */

 Registre.h.ah = 2;                             /* Numro de fonction */
 Registre.h.bh = 0;                                     /* Page cran */
 Registre.h.dh = Ligne;                                /* Ligne cran */
 Registre.h.dl = Colonne;                            /* Colonne cran */
 int86(0x10, &Registre, &Registre);     /* Appeler l'interruption 10h */
}

/***********************************************************************
* CLS : Effacer page cran actuelle et placer curseur dans le coin     *
*       suprieur gauche                                               *
* Entre : Aucune                                                      *
* Sortie : Aucune                                                      *
***********************************************************************/

void Cls( void )

{
 ScrollUp(0, NOF, 0, 0, 79, 24);                   /* Effacer l'cran */
 SetPos(0, 0);                                   /* Placer le curseur */
}

/***********************************************************************
* CONFIGECRAN : Configure l'cran pour la sortie du                    *
*               rpertoire                                             *
* Entre : Aucune                                                      *
* Sortie : Aucune                                                      *
***********************************************************************/

void ConfigEcran( void )
{
 BYTE i;                                        /* Compteur de boucle */

 Cls();                                            /* Effacer l'cran */
 Print( 14, EZ, NOF,
        "ͻ");
 Print( 14, EZ+1, NOF,
        " Nom         Taille   Date       Heure  RHSVD");
 Print( 14, EZ+2, NOF,
        "Ķ");
 for (i = EZ+3; i < EZ+3+EINTR; i++)
  Print( 14, i, NOF,
         "                                             ");
 Print( 14, EZ+EINTR+3, NOF,
        "ͼ");
}

/***********************************************************************
* PRINTDATA: Afficher les informations  propos d'une entre           *
* Entre : SAISIE = Ptr sur une structure Dir avec des informations    *
*                   de fichier                                         *
*           LIGNE = Ligne cran de l'entre                            *
* Sortie : Aucune                                                      *
***********************************************************************/

void PrintData(DIRSTRUCT *Saisie, BYTE Ligne)
{
 BYTE i, j;                                     /* Compteur de boucle */
 static char *Mois[] =         /* Vecteur avec pointeurs sur les mois */
        {
          "Jan", "Fv", "Mar", "Avr", "Mai", "Jun",
          "Jul", "Aug", "Sep", "Oct", "Nov", "Dc"
        };

          /*-- Afficher les informations de fichier ------------------*/

 Print(15, Ligne, NOF, "%s", Saisie->NAME);

 Print( 28, Ligne, NOF, "%7lu", Saisie->SIZE);
 Print( 36, Ligne, NOF, " %2d %s %4d", Saisie->DATE & 31,
        Mois[((Saisie->DATE >> 5) & 15) - 1],
        (Saisie->DATE >> 9) + 1980);
 Print(49, Ligne, NOF, "  %2dh%2d", Saisie->TIME >> 11,
                                  (Saisie->TIME >> 5) & 63 );

 for (i = j = 1; i <= 16; i <<= 1, ++j)       /* Attributs de fichier */
  Print( 58+j, Ligne, NOF, "%c", (Saisie->ATTRIBUT & i) ? 'X' : ' ' );
}

/***********************************************************************
* DIR : Contrle la lecture et la sortie du rpertoire                 *
* Entre : CHEMIN   = Ptr sur chemin de rech. avec masque fichier      *
*          ATTRIBUT = Attributs de recherche                           *
* Sortie : Aucune                                                      *
***********************************************************************/

void Dir( char *Chemin, BYTE Attribut )
{
 int       NbEntrees,              /* Nombre total d'entres trouves */
           NbImage;                  /* Nombre d'entres dans l'image */
 DIRSTRUCT Saisie;                        /* Une entre de rpertoire */

 ConfigEcran();    /* Construire l'cran pour la sortie de rpertoire */

 NbImage = NbEntrees = 0; /* Aucune entre encore affiche ds fentre */
                              /* Aucune entre n'a t encore trouve */
 if( !FINDFIRST(Chemin, &Saisie, Attribut) )     /* Rech. 1re entre */
 {                                               /* Un fichier trouv */
   do    /* Sortir le fichier et rechercher le suivant avec GetNext() */
   {
     PrintData(&Saisie, EZ+EINTR+2);             /* Afficher l'entre */
     if( ++NbImage == EINTR )          /* La fentre est-elle pleine? */
     {
       NbImage = 0;                  /* Remplir  nouveau une fentre */
       Print(14, EZ+4+EINTR, INV,
          "         Veuillez appuyer sur une touche           ");
       getch();                    /* Attendre l'appui sur une touche */
       Print(14, EZ+4+EINTR, NOF,
          "                                                   ");
     }
     ScrollUp(1, NOF, 15, EZ+3, 63, EZ+2+EINTR);
     Print(15, EZ+2+EINTR, NOF,
        "                                             ");
     ++NbEntrees;
   }
   while( !FINDNEXT( &Saisie ) );  /* Fin s'il n'y a plus de fichiers */
 }

 SetPos(14, EZ+4+EINTR);
 switch (NbEntrees)
 {
   case 0  : printf("Aucun fichier trouv");
             break;
   case 1  : printf("Un fichier trouv");
             break;
   default : printf("%d Fichiers trouves", NbEntrees);
             break;
 }
}

/**********************************************************************/
/**                           PROGRAMME PRINCIPAL                    **/
/**********************************************************************/

void main( int Nombre, char *Arguments[] )
{
 switch ( Nombre )        /* Ragir en fonction du nombre d'arguments */
 {                                                        /* transmis */
   case 1  : Dir("*.*", FA_ALL );   /* Afficher tous fichiers du rp. */
             break;                                       /* en cours */
   case 2  : Dir( Arguments[1], FA_ALL ); /* Affiche fichiers du rp. */
             break;                                       /* spcifi */
   default : printf("Nombre de paramtres incorrect\n");
 }
}
