/***********************************************************************
*                             H M A C . C                              *
**--------------------------------------------------------------------**
*  Sujet          : Dmonstration d'accs direct au HMA sans l'aide    *
*                   d'aucun pilote particulier.                        *
**--------------------------------------------------------------------**
*  Auteur         : MICHAEL TISCHER                                    *
*  Dvelopp le   : 27.07.1990                                         *
*  Dernire m.  j: 29.07.1990                                         *
**--------------------------------------------------------------------**
*  (MICROSOFT C)                                                       *
*  Cration       : CL /AS /Zp hmac.c hmaca                            *
*  Appel          : hmac                                               *
**--------------------------------------------------------------------**
*  (BORLAND TURBO C)                                                   *
*  Cration       : avec un fichier de projet contenant les fichiers   *
*                     hmac.c                                           *
*                     hmaca.obj                                        *
***********************************************************************/

/*-- Intgrer les fichiers include -----------------------------------*/

#include <dos.h>                         /* Pour appels interruptions */
#include <stdio.h>

#ifdef __TURBOC__
  #include <alloc.h>
#else
  #include <malloc.h>
#endif

/*-- Constantes ------------------------------------------------------*/


#define TRUE  ( 0 == 0 )
#define FALSE ( 0 == 1 )

/*-- Macros ----------------------------------------------------------*/

#ifndef MK_FP
  #define MK_FP(seg,ofs) \
         ((void far *) (((unsigned long)(seg) << 16) | (unsigned)(ofs)))
#endif

#define Hi(x) (*((BYTE *) &x+1))                  /* Hi Byte d'un int */
#define Lo(x) (*((BYTE *) &x))                    /* Lo Byte d'un int */

/*-- Dclarations des types ------------------------------------------*/

typedef unsigned char BYTE;
typedef BYTE BOOL;
typedef unsigned WORD;

/*-- Dclarations externes -------------------------------------------*/

extern BOOL HMAAvail( void );                          /* HMA dispo ? */
extern BOOL GateA20( BOOL libre );             /* librer/bloquer A20 */
extern BOOL IsA20On( void );                          /* A20 libr ? */

/***********************************************************************
* HMATest : Dmonstration de l'accs au HMA                            *
**--------------------------------------------------------------------**
* Entre : aucune                                                      *
***********************************************************************/

void HMATest( void)

{
 BYTE far * hmap;                                 /* Pointeur sur HMA */
 WORD i,                                     /* Compteur d'itrations */
      err;                       /* Nombre d'erreurs en accs  l'HMA */

 if( IsA20On() )
   printf( "Le canal d'adresse A20 est dj libr!\n" );
 else
   if( GateA20( TRUE ) == FALSE  || IsA20On() == FALSE )
   {
     printf( "Attention! Le canal d'adresses A20 n'a pu tre" \
             "libr." );
     return;
   }
   else
     printf( "L'accs  l'HMA vient d'tre libr.\n" );

 hmap = MK_FP( 0xFFFF, 0x0010 );                  /* pointeur sur HMA */
 err  = 0;                                 /* aucune erreur jusqu'ici */
 for( i = 1; i < 65520; ++i, ++hmap )
 {                                 /* Teste chaque adresse sparment */
   printf( "\rAdresse: %u", i );
   *hmap = i % 256;                          /* Ecrire dans l'adresse */
   if( *hmap != i % 256 )                             /* et la relire */
   {                                                       /* Erreur! */
     printf( " ERREUR!\n" );
     ++err;
   }
 }

 printf( "\n" );
 if ( err == 0 )                          /* Evaluer rsultat du test */
   printf( "HMA ok, aucune adresse incorrecte.\n" );
 else
   printf( "ATTENTIOn! %d adresses incorrectes dcouvertes " \
           "dans le HMA!\n", err );
 GateA20( FALSE );                     /* Dsactiver canal d'adresses */
}

/***********************************************************************
*                     P R O G R A M M E   P R I N C I P A L            *
***********************************************************************/

void main( void )
{
 int   i;                                    /* Compteur d'itrations */

 for( i = 1; i < 25; ++i )                         /* Effacer l'cran */
   printf ( "\n" );

 printf("HMAC  -  Programme dmo HMA par MICHAEL TISCHER\n\n" );
 if( HMAAvail() )
 {
   HMATest();                                             /* Test HMA */
   printf( "\n" );
 }
 else
   printf( "Aucun accs possible  l'HMA.\n" );
}
