/***********************************************************************
*                         R A W _ C O O K C                            *
**--------------------------------------------------------------------**
*    Fonction       : offre deux fonctions permettant de faire passer  *
*                     un driver de caractre en mode RAW ou en mode    *
*                     COOKED.                                          *
**--------------------------------------------------------------------**
*    Auteur         : MICHAEL TISCHER                                  *
*    Dvelopp le   : 16/08/1987                                       *
*    Dernire modif.: 29/02/1989                                       *
**--------------------------------------------------------------------**
*    (MICROSOFT C)                                                     *
*    Cration       : CL /AS RAW_COOK.C                                *
*    Appel          : RAW_COOK                                         *
**--------------------------------------------------------------------**
*    (BORLAND TURBO C)                                                 *
*    Cration       : Avec instruction RUN dans ligne d'instruction    *
*                     (sans fichier Project)                           *
***********************************************************************/

/*== Intgrer fichiers Include =======================================*/
#include <dos.h>
#include <stdio.h>
#include <conio.h>

/*== Constantes ======================================================*/
#define ENTSTAND 0                 /* handle 0 = priph. d'entre std */
#define SORSTAND 1                /* handle 1 = priph. de sortie std */

/***********************************************************************
* GETMODE: lit l'attribut d'un driver de priphrique                  *
* Entre : le handle transmis doit tre reli au priphrique         *
*          appeler.                                                    *
* Sortie : L'attribut de priphrique                                  *
***********************************************************************/

int GetMode( int Handle )
{
 union REGS Register;                  /* Reg. d'appel d'interruption */

 Register.x.ax = 0x4400;   /* Numro de fonction pour IOCTL: Get Mode */
 Register.x.bx = Handle;
 intdos(&Register, &Register);   /* Appeler interruption du DOS 21(h) */
 return(Register.x.dx);       /* Transmettre attribut de priphrique */
}

/***********************************************************************
* SETRAW: fait passer un driver de caractre en mode RAW               *
* Entre : le handle transmis doit tre reli au priphrique         *
*          appeler                                                     *
* Sortie : Aucune                                                      *
***********************************************************************/

void SetRaw( int Handle )
{
 union REGS Register;                  /* Reg. d'appel d'interruption */

 Register.x.ax = 0x4401;              /* N fonction IOCTL : Set Mode */
 Register.x.bx = Handle;
 Register.x.dx = (GetMode(Handle) & 255) | 32;  /* Nvl attrb. priph. */
 intdos(&Register, &Register);   /* Appeler interruption du DOS 21(h) */
}

/***********************************************************************
* SETCOOKED: fait passer un driver de caractre en mode COOKED         *
* Entre : le handle transmis doit tre reli au priphrique         *
*          appeler.                                                    *
* Sortie : Aucune                                                      *
***********************************************************************/

void SetCooked( int Handle )
{
 union REGS Register;                  /* Reg. d'appel d'interruption */

 Register.x.ax = 0x4401;              /* N fonction IOCTL : Set Mode */
 Register.x.bx = Handle;
 Register.x.dx = GetMode(Handle) & 223; /* Nouvel attribut de priph. */
 intdos(&Register, &Register);   /* Appeler interruption du DOS 21(h) */
}

/***********************************************************************
* SORTIETEST: sort une chane de test 1000 fois sur le priphrique    *
*             de sortie standard.                                      *
* Entre : Aucune                                                      *
* Sortie : Aucune                                                      *
***********************************************************************/

void SortieTest( void )
{
 int          i;                                /* Variable de boucle */
 static char  Test[] = "Test.... ";              /* Le texte  sortir */

 printf("\n");
 for( i = 0; i < 1000; i++ )                      /* Sortir 1000 fois */
   fputs( Test, stdout );  /* Sortir chane sur priph. de sortie std */
 printf("\n");
}

/**********************************************************************/
/**                         PROGRAMME PRINCIPAL                      **/
/**********************************************************************/

void main()

{
 printf("\nRAWCOOKC (c) 1987, 92 by Michael TISCHER\n\n");
 printf("Le driver de console (Clavier, cran) se trouve maintenant\n");
 printf("en mode RAW. C'est pourquoi, lors des sorties suivantes,\n");
 printf("les caractres de commande comme <CTRL-S> par exemple ne\n");
 printf("seront pas identifis.\n");
 printf("Essayez et vous verrez.\n\n");
 printf("Frappez une touche pour commencer...");
 getch();                                      /* Attendre une touche */
 SetRaw(ENTSTAND);      /* Faire passer driver de console en mode RAW */
 SortieTest();
 while( kbhit())            /* Eliminer du buffer clavier les touches */
                                              /* entres entre-temps. */
 printf("Le driver de console se trouve maintenant en mode COOKED.\n");
 printf("Les touches de commande comme <CTRL-S> par exemple, sont \n");
 printf("identifies lors de la sortie et traites en consquence !\n");
 printf("Veuillez frapper une touche pour commencer...");
 getch();                                      /* Attendre une touche */
 SetCooked(ENTSTAND);   /* Faire passer driver console en mode COOKED */
 SortieTest();
}