/**********************************************************************/
/*                         S O U R I S C . C                          */
/*--------------------------------------------------------------------*/
/*    Fonction       : Fournit diffrentes fonctions pour le travail  */
/*                     avec la souris                                 */
/*--------------------------------------------------------------------*/
/*    Auteur         : MICHAEL TISCHER                                */
/*    Dvelopp le   : 20/04/1989                                     */
/*    Dernire modif.: 22/04/1989                                     */
/*--------------------------------------------------------------------*/
/*    Microsoft C                                                     */
/*    Cration       : CL /AS SOURISC.C SOURISCA.OBJ                  */
/*    Appel          : SOURISC                                        */
/*--------------------------------------------------------------------*/
/*    Turbo C (environnement intgr)                                 */
/*    Cration       : avec fichier Project de contenu suivant :      */
/*                       SOURISC                                      */
/*                       SOURISCA.OBJ                                 */
/*                     avec le modle de mmoire SMALL.               */
/*                     Le Stack Checking doit tre dsactiv.         */
/*    Appel          : SOURIS                                         */
/**********************************************************************/

/*== Intgrer les fichiers Include ===================================*/

#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

extern void far AssHand( void );            /* Dclaration externe du */
                                        /* gestionnaire en assembleur */
/*== Typedefs ========================================================*/

typedef unsigned char BYTE;           /* Nous nous bricolons un octet */
typedef unsigned long PTRVIEW; /* Masque pour le curseur de la souris */
typedef struct {                            /* Dcrit une zone souris */
                BYTE x1,      /* Coordonnes du coin suprieur gauche */
                     y1,             /* et du coin infrieur droit de */
                     x2,                         /* la zone spcifie */
                     y2;
                PTRVIEW ptr_mask;    /* Masque pour le curseur souris */
               } ZONE;
typedef void (far * MOUHAPTR)( void ); /* Ptr sur driver d'vnements */

/*== Constantes ======================================================*/

#define TRUE  ( 1 == 1 )
#define FALSE ( 1 == 0 )

/*-- Codes Event -----------------------------------------------------*/

#define EV_MOU_MOVE      1                         /* Souris dplace */
#define EV_LEFT_PRESS    2       /* Bouton gauche de la souris appuy */
#define EV_LEFT_REL      4      /* Bouton gauche de la souris relch */
#define EV_RIGHT_PRESS   8        /* Bouton droit de la souris appuy */
#define EV_RIGHT_REL    16       /* Bouton droit de la souris relch */
#define EV_MOU_ALL      31              /* Tous les vnements souris */

#define AUCUNE_ZONE 255      /* Curseur de la souris pas dans zone xy */

/*-- Macros ----------------------------------------------------------*/

#define MouGetCol()       (ev_col)    /* Fournissent position et zone */
#define MouGetRow()       (ev_row)          /* de souris au moment de */
#define MouGetZone()      (ev_zon)   /* l'intervention de l'vnement */
#define MouAvail()        ( mavail ) /* Renvoie TRUE si souris existe */
#define MouGetActCol()    ( moucol )         /* Renvoient chaque fois */
#define MouGetActRow()    ( mourow )    /* position et zone actuelles */
#define MouGetActZon()    ( mouzon )                  /* de la souris */
#define MouIsLeftPress()  ( mouevent & EV_LEFT_PRESS )
#define MouIsLeftRel()    ( mouevent & EV_LEFT_REL )
#define MouIsRightPress() ( mouevent & EV_RIGHT_PRESS )
#define MouIsRightRel()   ( mouevent & EV_RIGHT_REL )
#define MouSetMoveAreaAll() MouSetMoveArea( 0, 0, tcol-1, tline-1 );

#define ELVEC(x) ( sizeof(x) / sizeof(x[0]) ) /* Nb d'lments dans X */

/*-- Macros pour crer le masque bits servant  dfinir            ---*/
/*-- l'apparence du curseur de la souris.                          ---*/
/*-- L'appel de MouPtrMask se prsente par exemple ainsi :         ---*/
/*--   MouPtrMask( PTRDIFCHAR( 'x' ), PTRINVCOL )                  ---*/
/*-- pour que le curseur de la souris apparaisse sous forme d'un   ---*/
/*-- petit X avec la couleur inverse du caractre qu'il recouvre.  ---*/

#define MouPtrMask( z, f )\
  ( (( (PTRVIEW) f) >> 8 << 24) + ((( PTRVIEW) z) >> 8 << 16) +\
    (((f) & 255) << 8) + ((z) & 255) )

#define PTRSAMECHAR   ( 0x00ff )                    /* Mme caractre */
#define PTRDIFCHAR(z) ( (z) << 8 )                 /* Autre caractre */
#define PTRSAMECOL    ( 0x00ff )                      /* Mme couleur */
#define PTRINVCOL     ( 0x7777 )                  /* Couleur inverse */
#define PTRSAMECOLC   ( 0x807f )          /* Mme couleur clignotante */
#define PTRINVCOLC    ( 0xF777 )      /* Couleur inverse clignotante */
#define PTRDIFCOL(f)  ( (f) << 8 )                   /* Autre couleur */
#define PTRDIFCOLC(f) (((f)|0x80) << 8)  /* Autre couleur clignotante */

#define ET  0               /* Combinaisons Event pour MouEventWait() */
#define OU 1

#define MOUINT(rin, rout) int86(0x33, &rin, &rout)
#define MOUINTX(rin, rout, sr) int86x(0x33, &rin, &rout, &sr)

/*-- Macros de conversion des coordonnes de la souris entre l'cran */
/*-- virtuel de la souris et l'cran de texte */

#define XTOCOL(x) ( (x) >> 3 )                      /* X divis par 8 */
#define YTOROW(y) ( (y) >> 3 )                 /* Ligne divise par 8 */
#define COLTOX(c) ( (c) << 3 )                            /* C fois 8 */
#define ROWTOY(r) ( (r) << 3 )                         /* Ligne par 8 */

/*== Variables globales ==============================================*/

BYTE tline,                              /* Nombre de lignes de texte */
     tcol,                             /* Nombre de colonnes de texte */
     mavail = FALSE;                /* Est TRUE, si souris disponible */

/*-- Masque pour le curseur standard de la souris --------------------*/

PTRVIEW stdptr = MouPtrMask( PTRSAMECHAR, PTRINVCOL );

BYTE    * bufz,         /* Ptr sur buffer pour identification de zone */
        nmb_zones = 0;               /* Aucune zone dfinie jusqu'ici */

ZONE * zone_act;               /* Pointeur sur vecteur de zone actuel */
int     blen;                 /* Longueur du buffer de zone en octets */

/*-- Variables dfinies lors de chaque appel du gestionnaire souris */

BYTE mouzon = AUCUNE_ZONE,                 /* Zone de souris actuelle */
     moucol,                 /* Colonne de la souris (cran de texte) */
     mourow;                   /* Ligne de la souris (cran de texte) */
int  mouevent = EV_LEFT_REL + EV_RIGHT_REL;    /* Masque d'vnements */

/*-- Variables qui ne sont dfinies par le gestionnaire de la      ---*/
/*-- souris que lorsqu'intervient un vnement attendu             ---*/

BYTE ev_zon,                   /* Zone dans laquelle figure la souris */
     ev_col,                                  /* Colonne de la souris */
     ev_row;                                    /* Ligne de la souris */

/***********************************************************************
*  Fonction         : M o u D e f i n e P t r                          *
**--------------------------------------------------------------------**
*  Fonction         : Dfinit les masques curseur et cran dfinissant *
*                     l'apparence du curseur de la souris              *
*  Paramtres en entre : MASK = les deux masques bits combins en une *
*                                valeur 32 bits du type UNSIGNED LONG  *
*  Valeur Return    : Aucune                                           *
*  Infos            : - Les 16 bits de plus fort poids de MASK repr-  *
*                       sentent le masque cran, les 16 bits de plus   *
*                       faible poids le masque curseur                 *
***********************************************************************/

#pragma check_stack(off)                 /* Pas de Stack Checking ici */

void MouDefinePtr( PTRVIEW mask )
{
 static PTRVIEW anciencurseur = (PTRVIEW) 0;  /* Dernire valeur MASK */
 union REGS regs; /* Registres du processeur pour l'appel d'interrup. */

 if ( anciencurseur != mask )      /* Modification au dernier appel ? */
  {                                                            /* Oui */
   regs.x.ax = 0x000a;         /* N fct pour "Set text pointer type" */
   regs.x.bx = 0;                           /* Fixer curseur logiciel */
   regs.x.cx = mask;               /* Le mot faible est le masque AND */
   regs.x.dx = mask >> 16;           /* Le mot fort est le masque XOR */
   MOUINT(regs, regs);              /* Appeler le driver de la souris */
   anciencurseur = mask;             /* Ranger le nouveau masque bits */
  }
}

/***********************************************************************
*  Fonction         : M o u E v e n t H a n d l e r                    *
**--------------------------------------------------------------------**
*  Fonction         : Est appel par le driver de la souris  travers  *
*                     la routine assembleur AssHand ds qu'intervient  *
*                     un vnement concernant la souris.               *
*  Paramtres en entre : EvFlags  = Masque Event de l'vnement       *
*                         ButState = Etat des boutons de la souris     *
*                         X, Y     = Position actuelle du curseur de   *
*                                    la souris, dj convertie vers le *
*                                    systme de coordonnes de texte   *
*  Valeur Return    : Aucune                                           *
*  Infos            : - Cette fonction est seulement destine  tre   *
*                       appele par le driver de la souris et ne doit  *
*                       pas tre appele par une autre fonction.       *
***********************************************************************/

void MouEventHandler( int EvFlags, int ButState, int x, int y )
{
 #define LBITS ( EV_LEFT_PRESS | EV_LEFT_REL )
 #define RBITS ( EV_RIGHT_PRESS | EV_RIGHT_REL )

 unsigned nouzon;                       /* Numro de la nouvelle zone */

 mouevent &= ~1;                                  /* Masquer le bit 0 */
 mouevent |= ( EvFlags & 1 );  /* Copier le bit 0  partir de EvFlags */

 if ( EvFlags & LBITS )/* Bouton gauche de la souris relch/appuy ? */
  {                                                            /* Oui */
   mouevent &= ~LBITS;                      /* Masquer tat antrieur */
   mouevent |= ( EvFlags & LBITS );          /* Incruster nouvel tat */
  }

 if ( EvFlags & RBITS ) /* Bouton droit de la souris relch/appuy ? */
  {                                 /* Oui, masquer et incruster bits */
   mouevent &= ~RBITS;                      /* Masquer tat antrieur */
   mouevent |= ( EvFlags & RBITS );          /* Incruster nouvel tat */
  }

 moucol = x;                /* Convertir colonne et colonnes de texte */
 mourow = y;                    /* Convertir ligne en lignes de texte */

 /*-- Dterminer zone dans laquelle figure la souris et examiner   ---*/
 /*-- si cette zone s'est modifie depuis le dernier appel. Dans   ---*/
 /*-- ce cas, l'apparence du curseur de la souris doit tre        ---*/
 /*-- redfinie.                                                   ---*/

 nouzon = *(bufz + mourow * tcol + moucol);           /* Retirer zone */
 if ( nouzon != mouzon )                           /* Nouvelle zone ? */
  MouDefinePtr((nouzon==AUCUNE_ZONE) ? stdptr :
                                        (zone_act+nouzon)->ptr_mask);
 mouzon = nouzon;      /* Ranger numro de zone dans variable globale */
}

#pragma check_stack                /* Restaurer ancien tat en ce qui */
#pragma check_stack               /* concerne le Stack Checking       */

/***********************************************************************
*  Fonction         : M o u I B u f F i l l                            *
**--------------------------------------------------------------------**
*  Fonction         : Stocke le code de zone pour une zone de l'cran  *
*                     dtermine  l'intrieur de la mmoire cran     *
*                     interne du module                                *
*  Paramtres en entre : x1, y1 = coin suprieur gauche de zone cran *
*                         x2, y2 = coin infrieur droit de zone cran  *
*                     CODE   = Code de zone                            *
*  Valeur Return    : Aucune                                           *
*  Infos            : Cette fonction ne doit tre appele qu'         *
*                     l'intrieur de ce module.                        *
***********************************************************************/

static void MouIBufFill( BYTE x1, BYTE y1,
                         BYTE x2, BYTE y2, BYTE code )
{
 register BYTE * lptr;             /* Pointeur sur la mmoire de zone */
 BYTE i, j;                                     /* Compteur de boucle */

 lptr = bufz + y1 * tcol + x1;      /* Pointeur sur la premire ligne */

 /*-- Parcourir les diffrentes lignes -------------------------------*/
 for (j=x2 - x1 + 1 ; y1 <= y2; ++y1, lptr+=tcol )
  memset( lptr, code, j );                              /* Fixer code */
}

/***********************************************************************
*  Fonction         : M o u D e f Z o n e                              *
**--------------------------------------------------------------------**
*  Fonction         : Permet de dfinir diffrentes zones de l'cran   *
*                     qui seront dotes de codes respectifs pour le    *
*                     travail avec la souris.                          *
*  Params. en entre: - NOMBRE = Nombre de zones de l'cran            *
*                     - PTR    = Pointeur sur vecteur avec les des-    *
*                                cripteurs de zone du type ZONE        *
*  Valeur Return    : Aucune                                           *
*  Infos            : - Le code AUCUNE_ZONE est affect aux zones de   *
*                       l'cran restes libres.                        *
*                     - Lorsque la souris pntre dans l'une des zones *
*                       de l'cran spcifies, le gestionnaire de la   *
*                       souris commute automatiquement sur l'apparence *
*                       du curseur de la souris dfinie par le         *
*                       descripteur de zone correspondant.             *
*                     - Comme seul le pointeur transmis est stock,    *
*                       mais que le vecteur transmis n'est pas copi   *
*                       dans un buffer spar, le contenu du vecteur   *
*                       ne doit pas tre modifi jusqu'au prochain     *
*                       appel de cette fonction.                       *
***********************************************************************/

void MouDefZone( BYTE nombre, ZONE * ptr )
{
 register BYTE i,                               /* Compteur de boucle */
               zone;                             /* Zone de la souris */

 zone_act = ptr;                       /* Ranger pointeur sur vecteur */
 nmb_zones = nombre;                            /* et nombre de zones */
 memset( bufz, AUCUNE_ZONE, blen );
 for (i=0 ; i<nombre ; ++ptr )
  MouIBufFill( ptr->x1, ptr->y1, ptr->x2, ptr->y2, i++);

 /*-- Rdfinir le curseur de la souris ------------------------------*/

 zone = *(bufz + mourow * tcol + moucol);       /*Zone souris actuelle*/
 MouDefinePtr( ( zone == AUCUNE_ZONE ) ? stdptr
               : (zone_act+zone)->ptr_mask );
}

/***********************************************************************
*  Fonction         : M o u E v e n t W a i t                          *
**--------------------------------------------------------------------**
*  Fonction         : Attend l'intervention d'un vnement dtermin   *
*                     sur le clavier.                                  *
*  Params. en entre: TYP        = Dfinit la combinaison entre les    *
*                                  diffrents vnements.              *
*                     WAIT_EVENT = Masque bits spcifiant l'vnement  *
*                                  attendu.                            *
*  Valeur Return    : Masque bits dcrivant le ou les vnements       *
*                     intervenu(s)                                     *
*  Infos            : - WAIT_EVENT peut tre compos par combinaison   *
*                       Ou entre les diverses constantes, telles que   *
*                       EV_MOU_MOVE ou EV_LEFT_PRESS par exemple       *
*                     - ET ou OU peuvent tre spcifis pour le TYP.   *
*                       Avec ET, la fonction ne revient au programme   *
*                       d'appel qu'une fois que tous les vnements    *
*                       attendus sont intervenus simultanment, alors  *
*                       que OU se contente de l'intervention d'un      *
*                       vnement au moins.                            *
***********************************************************************/

int MouEventWait( BYTE typ, int wait_event )
{
 int act_event;                             /* Le masque Event actuel */
 register BYTE colonne = moucol,          /* Dernire position souris */
               ligne  = mourow;
 BYTE fin = FALSE;             /* Devient TRUE si vnement intervenu */

 while ( !fin )        /* Rpter jusqu' ce qu'vnement intervienne */
  {
   /*-- Attendre que l'un des vnements intervienne -----------------*/

   if ( typ == ET )   /* ET : tous les vnements doivent se produire */
     while ( (act_event = mouevent) != wait_event)
      ;
   else                 /* OU : au moins un vnement doit intervenir */
     while ( ( (act_event = mouevent) & wait_event) == 0)
      ;

   act_event &= wait_event;   /* Ne laisser que les bits d'vnements */

       /*-- Lorsqu'on attend le dplacement de la souris, l'vnement */
        /*-- n'est accept que si le curseur de la souris a t amen */
          /*-- dans une autre ligne et/ou colonne de l'cran de texte */

   if ((wait_event & EV_MOU_MOVE) && colonne==moucol && ligne==mourow)
    {                     /* Souris dplace mais mme position cran */
     act_event &= (~EV_MOU_MOVE);                 /* Masquer bit Move */
     fin = (act_event != 0);           /* Reste-t-il des vnements ? */
    }
   else                                        /* Evnement intervenu */
    fin = TRUE;
  }
 ev_col = moucol;                       /* Conserver position et zone */
 ev_row = mourow;                        /* souris dans des variables */
 ev_zon = mouzon;                                         /* globales */
 return( act_event );                        /* Renvoyer masque Event */
}

/***********************************************************************
*  Fonction         : M o u I S e t E v e n t H a n d l e r            *
**--------------------------------------------------------------------**
*  Fonction         : Installe un gestionnaire d'vnements qui est    *
*                     appel par le driver de la souris lorsqu'un      *
*                     vnement souris dtermin intervient.           *
*  Params en entre : EVENT = Masque bits spcifiant l'vnement       *
*                             dont l'intervention doit entraner       *
*                             l'appel du gestionnaire de la souris.    *
*                     PTR   = Pointeur sur gestionnaire de la souris   *
*  Valeur Return    : Aucune                                           *
*  Infos            : - EVENT peut tre compos par combinaison Ou     *
*                       des diffrentes constantes telles que          *
*                       EV_MOU_MOVE ou EV_LEFT_PRESS du fichier        *
***********************************************************************/

static void MouISetEventHandler( unsigned event, MOUHAPTR ptr )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */
 struct SREGS sregs; /* Registre de segment pour l'appel d'interrupt. */

 regs.x.ax = 0x000C;              /* N fct. pour "Set Mouse Handler" */
 regs.x.cx = event;                    /* Charger masque d'vnements */
 regs.x.dx = FP_OFF( ptr );       /* Adresse d'offset du gestionnaire */
 sregs.es  = FP_SEG( ptr );     /* Adresse de segment du gestionnaire */
 MOUINTX( regs, regs, sregs );      /* Appeler le driver de la souris */
}

/***********************************************************************
*  Fonction         : M o u I G e t X                                  *
**--------------------------------------------------------------------**
*  Fonction         : Dtermine la colonne (de texte) dans laquelle    *
*                     figure le curseur de la souris.                  *
*  Params en entre : Aucun                                            *
*  Valeur Return    : La colonne de souris par rapport  cran texte   *
***********************************************************************/

static BYTE MouIGetX( void )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 regs.x.ax= 0x0003;             /* N fct.: pour "Get mouse position" */
 MOUINT( regs, regs );              /* Appeler le driver de la souris */
 return XTOCOL( regs.x.cx );         /* Convertir colonne et renvoyer */
}

/***********************************************************************
*  Fonction         : M o u I G e t Y                                  *
**--------------------------------------------------------------------**
*  Fonction         : Dtermine la ligne (de texte) dans laquelle      *
*                     figure le curseur de la souris.                  *
*  Params en entre : Aucun                                            *
*  Valeur Return    : La ligne de souris par rapport  cran de texte  *
***********************************************************************/

static BYTE MouIGetY( void )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 regs.x.ax= 0x0003;             /* N fct.: pour "Get mouse position" */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
 return YTOROW(regs.x.dx);             /* Convertir ligne et renvoyer */
}

/***********************************************************************
*  Fonction         : M o u S h o w M o u s e                          *
**--------------------------------------------------------------------**
*  Fonction         : Afficher curseur souris sur l'cran.             *
*  Params en entre : Aucun                                            *
*  Valeur Return    : Aucune                                           *
*  Infos            : Les appels de MouHidemMouse() et MouShowMouse()  *
*                     doivent s'quilibrer pour avoir un effet.        *
***********************************************************************/

void MouShowMouse( void )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 regs.x.ax = 0x0001;                    /* N fct.: pour "Show Mouse" */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
}

/***********************************************************************
*  Fonction         : M o u H i d e M o u s e                          *
**--------------------------------------------------------------------**
*  Fonction         : Eliminer curseur de la souris de l'cran.        *
*  Params en entre : Aucun                                            *
*  Valeur Return    : Aucune                                           *
*  Infos            : Les appels de MouHidemMouse() et MouShowMouse()  *
*                     doivent s'quilibrer pour avoir un effet.        *
***********************************************************************/

void MouHideMouse( void )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 regs.x.ax = 0x0002;                     /* N fct. pour "Hide Mouse" */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
}

/***********************************************************************
*  Fonction         : M o u S e t M o v e A r e a                      *
**--------------------------------------------------------------------**
*  Fonction         : Dfinit la zone de l'cran  l'intrieur de      *
*                     laquelle le curseur de la souris peut se dplacer*
*  Params en entre : x1, y1 = coordonnes du coin suprieur gauche    *
*                     x2, y2 = coordonnes du coin infrieur droit     *
*  Valeur Return    : Aucune                                           *
*  Infos            : - Les deux paramtres se rfrent  l'cran de   *
*                       texte et non  l'cran graphique virtuel de    *
*                       la souris                                      *
***********************************************************************/

void MouSetMoveArea( BYTE x1, BYTE y1, BYTE x2, BYTE y2 )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 regs.x.ax = 0x0008;            /* N fct. pour "Set vertical Limits" */
 regs.x.cx = ROWTOY( y1 );                 /* Conversion vers l'cran */
 regs.x.dx = ROWTOY( y2 );                    /* virtuel de la souris */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
 regs.x.ax = 0x0007;          /* N fct. pour "Set horizontal limits" */
 regs.x.cx = COLTOX( x1 );                 /* Conversion vers l'cran */
 regs.x.dx = COLTOX( x2 );                    /* virtuel de la souris */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
}

/***********************************************************************
*  Fonction         : M o u S e t S p e e d                            *
**--------------------------------------------------------------------**
*  Fonction         : Fixe le rapport entre la longueur d'un dplace-  *
*                     ment de la souris et le dplacement du curseur   *
*                     de la souris qui doit en rsulter.               *
*  Params en entre : - XSPEED = vitesse horizontalement               *
*                     - YSPEED = vitesse verticalement                 *
*  Valeur Return    : Aucune                                           *
*  Infos            : - Les deux paramtres sont exprims en units de *
*                       mickey / 8 points cran.                       *
***********************************************************************/

void MouSetSpeed( int xspeed, int yspeed )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 regs.x.ax = 0x000f;          /* N fct. "Set mickeys to pixel ratio" */
 regs.x.cx = xspeed;
 regs.x.dx = yspeed;
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
}

/***********************************************************************
*  Fonction         : M o u M o v e P t r                              *
**--------------------------------------------------------------------**
*  Fonction         : Amne le curseur de la souris dans une position  *
*                     dtermine de l'cran.                           *
*  Params en entre : - COL = nouvelle colonne de l'cran              *
*                     - ROW = nouvelle ligne de l'cran                *
*  Valeur Return    : Aucune                                           *
*  Infos            : - Les deux paramtres se rfrent  l'cran de   *
*                       texte et non  l'cran graphique virtuel de    *
*                       la souris                                      *
***********************************************************************/

void MouMovePtr( int col, int row )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */
 unsigned nouzon;          /* Zone dans laquelle la souris est amene */

 regs.x.ax = 0x0004;          /* N fct. "Set mouse pointer position" */
 regs.x.cx = COLTOX( moucol = col );  /* Convertir coordonnes et les */
 regs.x.dx = ROWTOY( mourow = row );/* stocker dans variables globales*/
 MOUINT(regs, regs);                /* Appeler le driver de la souris */

 nouzon = *(bufz + mourow * tcol + moucol);           /* Retirer zone */
 if ( nouzon != mouzon )                           /* Nouvelle zone ? */
  MouDefinePtr((nouzon==AUCUNE_ZONE) ? stdptr :
                                        (zone_act+nouzon)->ptr_mask);
 mouzon = nouzon;              /* Ranger n de zone dans var. globale */
}

/***********************************************************************
*  Fonction         : M o u S e t D e f a u l t P t r                  *
**--------------------------------------------------------------------**
*  Fonction         : Dfinit l'apparence du curseur de la souris pour *
*                     les zones de l'cran qui n'ont pas t dfinies  *
*                     avec MouDefZone.                                 *
*  Params en entre : STANDARD = Masque bits pour curseur souris stand.*
*  Valeur Return    : Aucune                                           *
***********************************************************************/

void MouSetDefaultPtr( PTRVIEW standard )
{
 stdptr = standard;       /* Ranger masque bits dans variable globale */

 /*-- Si la souris ne figure actuellement dans aucune zone, la     ---*/
 /*-- nouvelle apparence du curseur est directement active        ---*/

 if ( MouGetZone() == AUCUNE_ZONE )             /* Dans aucune zone ? */
  MouDefinePtr( standard );                                    /* Non */
}

/***********************************************************************
*  Fonction         : M o u E n d                                      *
**--------------------------------------------------------------------**
*  Fonction         : Met fin au travail avec les fonctions du module  *
*                     Mousec.                                          *
*  Params en entre : Aucun                                            *
*  Valeur Return    : Aucune                                           *
*  Infos            : Cette fonction est appele automatiquement  la  *
*                     fin d'un programme,  condition que MouInstall   *
*                     ait t appel auparavant.                       *
***********************************************************************/

void MouEnd( void )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 MouHideMouse();          /* Eliminer curseur de la souris de l'cran */
 regs.x.ax = 0;            /* Rinitialisation du driver de la souris */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */

 free( bufz );                   /* Librer  nouveau mmoire alloue */
}

/***********************************************************************
*  Fonction         : M o u I n i t                                    *
**--------------------------------------------------------------------**
*  Fonction         : Dirige le travail avec le module Mousec et       *
*                     initialise les diffrentes variables             *
*  Params en entre : Colonnes, = la rsolution de l'cran de texte    *
*                     Lignes                                           *
*  Valeur Return    : TRUE si une souris est installe, sinon FALSE    *
*  Infos            : Cette fonction doit tre la premire fonction de *
*                     ce module  tre appele.                        *
***********************************************************************/

BYTE MouInit( BYTE colonnes, BYTE lignes )
{
 union REGS regs;/* Registres du processeur pour l'appel d'interrupt. */

 tline = lignes;                    /* Stocker nombre de lignes et de */
 tcol  = colonnes;            /* colonnes dans des variables globales */

 atexit( MouEnd );            /* Appeler MouEnd  la fin du programme */

 /*-- Allouer et remplir buffer pour zones souris --------------------*/

 bufz = (BYTE *) malloc( blen = tline * tcol );
 MouIBufFill( 0, 0, tcol-1, tline-1, AUCUNE_ZONE );

 regs.x.ax = 0;                    /* Initialiser driver de la souris */
 MOUINT(regs, regs);                /* Appeler le driver de la souris */
 if ( regs.x.ax != 0xffff )         /* Driver de la souris install ? */
  return FALSE;                                                /* Non */

 MouSetMoveAreaAll();                    /* Fixer zone de dplacement */

 moucol = MouIGetX();                    /* Charger position actuelle */
 mourow = MouIGetY();     /* de la souris dans des variables globales */

 /*-- Installer gestionnaire d'vnements assembleur "AssHand" -------*/
 MouISetEventHandler( EV_MOU_ALL, (MOUHAPTR) AssHand );

 return mavail = TRUE;                     /* La souris est installe */
}

/***********************************************************************
*                   P R O G R A M M E   P R I N C I P A L              *
***********************************************************************/

int main( void )
{
 static ZONE zones[] =          /* Les diffrentes zones de la souris */
  {
   {  0,  0, 79,  0, MouPtrMask( PTRDIFCHAR(0x18), PTRINVCOL)  },
   {  0,  1,  0, 23, MouPtrMask( PTRDIFCHAR(0x1b), PTRINVCOL)  },
   {  0, 24, 78, 24, MouPtrMask( PTRDIFCHAR(0x19), PTRINVCOL)  },
   { 79,  1, 79, 23, MouPtrMask( PTRDIFCHAR(0x1a), PTRINVCOL)  },
   { 79, 24, 79, 24, MouPtrMask( PTRDIFCHAR('X'),  PTRDIFCOLC(0x40) ) },
  };

 printf("\nSOURIS - (c) 1989 by MICHAEL TISCHER\n\n");
 if ( MouInit( 80, 25 ) )          /* Initialiser module de la souris */
  {              /* Tout va bien, un driver de la souris est install */
   printf("Si vous dplacez le curseur de la souris sur l'cran,\n"\
          "et notamment le long des bords de l'cran, vous\n"\
          "constatez que l'apparence du curseur de la souris se\n"\
          "modifie en fonction de sa position.\n\n"
          "Pour mettre fin  cette dmo, amenez le curseur de la\n"\
          "souris dans le coin infrieur droit de l'cran puis\n"\
          "appuyez alors  la fois sur les boutons gauche et\n"\
          "droit de la souris.\n" );

   MouSetDefaultPtr( MouPtrMask( PTRDIFCHAR( '' ), PTRDIFCOL( 3 ) ) );
   MouDefZone( ELVEC( zones ), zones );                 /* Df. zones */
   MouShowMouse();       /* Afficher curseur de la souris sur l'cran */

   /*-- Attendre que les boutons gauche et droit de la souris       --*/
   /*-- soient appuys simultanment et que le curseur de la souris --*/
   /*-- figure  ce moment dans la zone 4                           --*/

   do                                               /* Boucle de test */
    MouEventWait( ET, EV_LEFT_PRESS | EV_RIGHT_PRESS );
   while ( MouGetZone() != 4 );

   return 0;                               /* Renvoyer code OK au DOS */
  }
 else               /* Pas de souris ou pas de driver souris install */
  {
   printf("Aucun driver de la souris n'est install !\n");
   return 1;                         /* Renvoyer code d'erreur au DOS */
  }
}
