{**********************************************************************}
{*                             D I R P 2                              *}
{*--------------------------------------------------------------------*}
{*    Fonction        : Affiche les fichiers d'un rp. quelconque     *}
{*                      y compris sous-rpertoires et noms de volumes *}
{*                      sur l'cran.                                  *}
{*                      La demande s'effectue avec les deux fonctions *}
{*                      Pascal First et FindNext de l'unit DOS.      *}
{*                      Reportez-vous galement au programme          *}
{*                      DIRP1.PAS.                                    *}
{*--------------------------------------------------------------------*}
{*    Auteur          : MICHAEL TISCHER                               *}
{*    Dvelopp le    :  8.07.1988                                    *}
{*    Dernire modif. : 15.03.1992                                    *}
{**********************************************************************}

program DIRP2;

Uses Crt, Dos;                         { Insrer les units CRT et DOS }

{-- Dclarations de type ----------------------------------------------}

type MonVec    = array[1..12] of string[3];         { Tableau des mois }

{-- Constantes --------------------------------------------------------}

const EINTR = 14;       { Autant d'entres sont visibles simultanment }
      Mois : MonVec = ( 'Jan', 'Fev', 'Mar', 'Avr', 'Mai', 'Jun',
                        'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

{**********************************************************************}
{* PRINTDATA: Afficher les informations  propos d'une entre         *}
{* Entre : DIRBUF = Structure de donnes avec informations de fichier*}
{* Sortie : Aucune                                                    *}
{**********************************************************************}

procedure PrintData( DirBuf : SearchRec );

var Compteur : byte;
    Date,                   { Pour tronquer le champ TIME en SearchRec }
    Time     : word;

type longrec = record         { Pour dcouper un mot LONG en deux Word }
                 LoWord,
                 HiWord  : word
               end;

begin
  writeln;          { Fait avancer la fentre d'une ligne vers le haut }

  write( DirBuf.Name );         { Le nom a t dj converti en Pascal }

  GotoXY(13, EINTR);
  write('', DirBuf.Size:7);

  Date := longrec(DirBuf.Time).HiWord;    { Date et Heure de SearchRec }
  Time := longrec(DirBuf.Time).LoWord;

  GotoXY(21, EINTR);
  write(' ', Date and 31:2,' ');                 { Dterminer le jour }
  write (Mois[Date shr 5 and 15]);                  { Afficher le mois }
  write(Date shr 9 + 1980:5);                     { Dterminer l'anne }
  GotoXY(34, EINTR);
  write('  ', Time shr 11:2, 'h');               { Dterminer l'heure }
  write(Time shr 5 and 63:2);                   { Dterminer la minute }

  GotoXY(44, EINTR);
  write('');            { Trait de sparation avec le champ prcdent }
  Compteur := 1;                              { Afficher les attributs }
  while ( Compteur < 32 ) do
    begin
      if( DirBuf.Attr and Compteur) <> 0 then
         write('X')
      else
         write(' ');
      Compteur := Compteur shl 1;
    end;
  write('');                         { Ct droit du cadre de fentre }
end;

{**********************************************************************}
{* ConfigEcran: Configure l'cran pour la sortie du                   *}
{*              rpertoire                                            *}
{* Entre : Aucune                                                    *}
{* Sortie : Aucune                                                    *}
{**********************************************************************}

procedure ConfigEcran;

var Compteur : integer;                           { Compteur de boucle }

begin
 ClrScr;                                             { Effacer l'cran }
 Window(14,(20-EINTR) shr 1+1,64,(20-EINTR) shr 1 +5+EINTR);
 GotoXY(1,1);       { Curseur dans le coin suprieur gauche de l'cran }

 write('ͻ');
 write(' Nom         Taille   Date       Heure  RHSVD');
 write('Ķ');

 for Compteur := 1 to EINTR do
   write('                                             ');
 write('ͼ');

 Window(15,(20-EINTR) shr 1+4,66,(20-EINTR) shr 1 +3+EINTR);
 GotoXY(1, EINTR);          { Curseur dans coin sup. gauche de l'cran }
end;

{**********************************************************************}
{* Dir: Contrle la lecture et la sortie du rpertoire                *}
{* Entre : CHEMIN    = Chemin de recherche avec masque de fichier    *}
{*          ATTRIBUT  = Attribut de recherche                         *}
{* Sortie : Aucune                                                    *}
{**********************************************************************}

procedure Dir( Chemin : string; Attr : byte );

var NbEntrees,                     { Nombre total des entres trouves }
    NbImage      : integer;            { Nombre d'entres dans l'image }
    Touche        : char;     { Sert  attendre l'appui sur une touche }
    DirBuf       : SearchRec;                  { Reoit une entre Dir }

begin
  clrscr;                                            { Effacer l'cran }
  ConfigEcran;       { Construire l'cran pour la sortie de rpertoire }

  NbImage := -1; { Aucune entre n'est encore affiche dans la fentre }
  NbEntrees := 0;               { Aucune entre n'a t encore trouve }
  FindFirst( Chemin, Attr, DirBuf );   { Rechercher la premire entre }
  if DOSError = 0 then
    repeat
      NbEntrees := succ(NbEntrees);         { Une autre entre trouve }
      NbImage := succ(NbImage);     { Une autre entre dans la fentre }
      if NbImage = EINTR then            { La fentre est-elle pleine? }
        begin                                                    { OUI }
          Window(14, (20-EINTR) shr 1 + 5 + EINTR,
                66, (20-EINTR) shr 1 + 6+ EINTR );
          GotoXY(1, 1);            { Curseur sur ligne inf. de fentre }
          TextBackground( LightGray );                    { Fond blanc }
          TextColor( Black );                       { Ecriture en noir }
          write('          Veuillez appuyer sur une touche          ');
          Touche := ReadKey;                          { Lire la touche }
          GotoXY(1, 1);     { Curseur dans coin sup. gauche de fentre }
          TextBackground( Black );                         { Fond noir }
          TextColor( LightGray );                  { Ecriture en blanc }
          write('                                                   ');
          Window(15,(20-EINTR) shr 1+4,65,(20-EINTR) shr 1 +3+EINTR);
          GotoXY(1, EINTR);        { Replace curseur sur ancienne pos. }
          NbImage := 0;                      { Reprendre le calcul  0 }
        end;
      PrintData( DirBuf );          { Afficher les donnes de l'entre }
      FindNext( DirBuf );              { Rechercher le fichier suivant }
    until DOSError <> 0;    { jusqu' ce qu'il n'y ait plus de fichier }

  Window(14,(20-EINTR) shr 1 +5+EINTR,65,(20-EINTR) shr 1 +6+EINTR);
  GotoXY(1, 1);  { Curseur dans le coin suprieur gauche de la fentre }
  TextBackground( LightGray );                            { Fond blanc }
  TextColor( Black );                               { Ecriture en noir }
  write('                                                   ');

  GotoXY(2, 1);
  case NbEntrees of
    0 : write('Aucun fichier trouv');
    1 : write('Un fichier trouv');
    else write(NbEntrees,' Fichiers trouvs')
  end;

 Window(1, 1, 80, 25);        { Reconfigurer l'cran comme une fentre }
end;

{**********************************************************************}
{**                           PROGRAMME PRINCIPAL                    **}
{**********************************************************************}

begin
  case ParamCount of        { Ragir en fonction du nombre d'arguments }
    0  : Dir( '*.*', AnyFile ); { Tous fichiers ds rpertoire en cours }
    1  : Dir( ParamStr(1), AnyFile );   { Afficher le fichier spcifi }
    else writeln('Nombre de paramtres incorrect');
  end;
end.
