{**********************************************************************}
{*                             N O K E Y P                            *}
{*--------------------------------------------------------------------*}
{*    Montre comment effacer le buffer du clavier                     *}
{*    pour protger l'utilisateur contre des saisies rsiduelles      *}
{*    lorsqu'il doit rpondre  des questions                         *}
{     importantes (par ex "Voulez-vous supprimer tel fichier ?")      *}
{*--------------------------------------------------------------------*}
{*    Auteur                : MICHAEL TISCHER                         *}
{*    Dvelopp le          :  01.01.1992                             *}
{*    Dernire modification :  01.01.1992                             *}
{**********************************************************************}

program NoKeyP;

uses Crt;

{**********************************************************************}
{* ClearKbBuffer : efface le contenu du buffer du clavier             *}
{* Entre : nant                                                     *}
{* Sortie : nant                                                     *}
{**********************************************************************}

procedure ClearKbBuffer;

begin
  inline( $fa );           { CLI, inhibe les interruptions matrielles }
  memw[$40:$1A] := memw[$40:$1C];   { Plus de caractre dans le buffer }
  inline( $fb );         { STI, rtablit les interruptions matrielles }
end;

{**********************************************************************}
{*                       Programme principal                          *}
{**********************************************************************}

var i,                                         { Compteur d'itrations }
    ccount : integer;            { Nombre de caractres dans le buffer }
    ch     : char;                              { mmorise les touches }

begin
  clrscr;
  writeln( 'NOKEYP  -  (c) 1992 by Michael Tischer' );
  writeln;
  writeln( 'A 0 les caractres du buffer vont tre effacs .' );
  writeln;

  for i := 10 downto 0 do    { Laisse le temps de taper des caractres }
    begin
      write( i:5 );
      delay( 750 );
    end;

  ClearKbBuffer;                           { Vide le buffer du clavier }

  {-- Affiche le nombre de caractres qui restent dans le buffer ------}

  ccount := 0;                               { Pas encore de caractre }
  writeln;
  writeln;
  writeln( 'Caractres dans le buffer :' );

  while KeyPressed do       { Reste-t-il un caractre dans le buffer ? }
    begin                         { Oui, lit le caractre et l'affiche }
      ch := ReadKey;
      write( '   ', ord(ch):5 );             { Affiche d'abord le code }
      if ord(ch) > 32 then                       { caractre spcial ? }
        write ( '(', ch, ')' );          { Non, affiche le caractre   }
      writeln;
      inc( ccount );
    end;
  if ccount = 0 then                              { Pas de caractre ? }
    writeln( '(Aucun)' );                                        { Non }
  writeln;
end.
